# RxJS Complete Module #

The Reactive Extensions for JavaScript's complete functionality is in the complete RxJS file which has many core components including the Schedulers, Disposables, Observable and Observer, but omits any testing capabilities.

This comes with both [`rx.all.js`](https://github.com/Reactive-Extensions/RxJS/blob/master/dist/rx.all.js) which is for use in modern development environments such as > IE9 and server-side environments such as Node.js.  We also have [`rx.all.compat.js`](https://github.com/Reactive-Extensions/RxJS/blob/master/dist/rx.all.compat.js) which has backwards compatibility to browsers which do not support all required ES5 features.

## Details ##

Files:
- [`rx.all.js`](https://github.com/Reactive-Extensions/RxJS/blob/master/dist/rx.all.js)
- [`rx.all.compat.js`](https://github.com/Reactive-Extensions/RxJS/blob/master/dist/rx.all.compat.js)

NPM Packages:
- [`rx`](https://www.npmjs.org/package/rx)

NuGet Packages:
- [`RxJS-All`](http://www.nuget.org/packages/RxJS-All/)

## Included Observable Operators ##

### `Observable Methods`
- [`amb`](../api/core/operators/amb.md)
- [`case | switchCase`](../api/core/operators/case.md)
- [`catch | catchException`](../api/core/operators/catch.md)
- [`concat`](../api/core/operators/concat.md)
- [`create | createWithDisposable`](../api/core/operators/create.md)
- [`defer`](../api/core/operators/defer.md)
- [`empty`](../api/core/operators/empty.md)
- [`for | forIn`](../api/core/operators/for.md)
- [`forkJoin`](../api/core/operators/forkjoin.md)
- [`from`](../api/core/operators/from.md)
- [`fromArray`](../api/core/operators/fromarray.md)
- [`fromCallback`](../api/core/operators/fromcallback.md)
- [`fromEvent`](../api/core/operators/fromevent.md)
- [`fromEventPattern`](../api/core/operators/fromeventpattern.md)
- [`fromNodeCallback`](../api/core/operators/fromnodecallback.md)
- [`fromPromise`](../api/core/operators/frompromise.md)
- [`generate`](../api/core/operators/generate.md)
- [`generateWithAbsoluteTime`](../api/core/operators/generatewithabsolutetime.md)
- [`generateWithRelativeTime`](../api/core/operators/generatewithrelativetime.md)
- [`if | ifThen`](../api/core/operators/if.md)
- [`interval`](../api/core/operators/interval.md)
- [`just`](../api/core/operators/return.md)
- [`merge`](../api/core/operators/merge.md)
- [`never`](../api/core/operators/never.md)
- [`of`](../api/core/operators/of.md)
- [`ofWithScheduler`](../api/core/operators/ofwithscheduler.md)
- [`onErrorResumeNext`](../api/core/operators/onerrorresumenext.md)
- [`range`](../api/core/operators/range.md)
- [`repeat`](../api/core/operators/repeat.md)
- [`return | returnValue`](../api/core/operators/return.md)
- [`start`](../api/core/operators/start.md)
- [`startAsync`](../api/core/operators/startasync.md)
- [`throw | throwException`](../api/core/operators/throw.md)
- [`timer`](../api/core/operators/timer.md)
- [`toAsync`](../api/core/operators/toasync.md)
- [`using`](../api/core/operators/using.md)
- [`when`](../api/core/operators/when.md)
- [`while | whileDo`](../api/core/operators/while.md)
- [`zip`](../api/core/operators/zip.md)
- [`zipArray`](../api/core/operators/ziparray.md)

### `Observable Instance Methods`
- [`aggregate`](../api/core/operators/aggregate.md)
- [`all`](../api/core/operators/all.md)
- [`amb`](../api/core/operators/ambproto.md)
- [`and`](../api/core/operators/and.md)
- [`any`](../api/core/operators/any.md)
- [`asObservable`](../api/core/operators/asobservable.md)
- [`average`](../api/core/operators/average.md)
- [`buffer`](../api/core/operators/buffer.md)
- [`bufferWithCount`](../api/core/operators/bufferwithcount.md)
- [`bufferWithTime`](../api/core/operators/bufferwithtime.md)
- [`bufferWithTimeOrCount`](../api/core/operators/bufferwithtimeorcount.md)
- [`catch | catchException`](../api/core/operators/catchproto.md)
- [`combineLatest`](../api/core/operators/combinelatest.md)
- [`concat`](../api/core/operators/concatproto.md)
- [`concatAll`](../api/core/operators/concatallproto.md)
- [`concatMap`](../api/core/operators/concatmap.md)
- [`connect`](../api/core/operators/connect.md)
- [`contains`](../api/core/operators/contains.md)
- [`controlled`](../api/core/operators/controlled.md)
- [`count`](../api/core/operators/count.md)
- [`defaultIfEmpty`](../api/core/operators/defaultifempty.md)
- [`delay`](../api/core/operators/delay.md)
- [`delayWithSelector`](../api/core/operators/delaywithselector.md)
- [`dematerialize`](../api/core/operators/dematerialize.md)
- [`distinct`](../api/core/operators/distinct.md)
- [`distinctUntilChanged`](../api/core/operators/distinctuntilchanged.md)
- [`do | doAction`](../api/core/operators/do.md)
- [`doWhile`](../api/core/operators/dowhile.md)
- [`elementAt`](../api/core/operators/elementat.md)
- [`elementAtOrDefault`](../api/core/operators/elementatordefault.md)
- [`every`](../api/core/operators/all.md)
- [`expand`](../api/core/operators/expand.md)
- [`filter`](../api/core/operators/where.md)
- [`finally | finallyAction`](../api/core/operators/finally.md)
- [`find`](../api/core/operators/find.md)
- [`findIndex`](../api/core/operators/findindex.md)
- [`first`](../api/core/operators/first.md)
- [`firstOrDefault`](../api/core/operators/firstordefault.md)
- [`flatMap`](../api/core/operators/selectmany.md)
- [`flatMapLatest`](../api/core/operators/flatmaplastest.md)
- [`flatMapObserver`](../api/core/operators/selectmanyobserver.md)
- [`forkJoin`](../api/core/operators/forkjoinproto.md)
- [`groupBy`](../api/core/operators/groupby.md)
- [`groupByUntil`](../api/core/operators/groupbyuntil.md)
- [`groupJoin`](../api/core/operators/groupjoin.md)
- [`ignoreElements`](../api/core/operators/ignoreelements.md)
- [`isEmpty`](../api/core/operators/isempty.md)
- [`join`](../api/core/operators/join.md)
- [`last`](../api/core/operators/last.md)
- [`lastOrDefault`](../api/core/operators/lastordefault.md)
- [`let | letBind`](../api/core/operators/let.md)
- [`manySelect`](../api/core/operators/manyselect.md)
- [`map`](../api/core/operators/select.md)
- [`max`](../api/core/operators/max.md)
- [`maxBy`](../api/core/operators/maxby.md)
- [`merge`](../api/core/operators/mergeproto.md)
- [`mergeAll`](../api/core/operators/mergeall.md)
- [`min`](../api/core/operators/min.md)
- [`minBy`](../api/core/operators/minby.md)
- [`multicast`](../api/core/operators/multicast.md)
- [`observeOn`](../api/core/operators/observeon.md)
- [`onErrorResumeNext`](../api/core/operators/onerrorresumenextproto.md)
- [`pairwise`](../api/core/operators/pairwise.md)
- [`partition`](../api/core/operators/partition.md)
- [`pausable`](../api/core/operators/pausable.md)
- [`pausableBuffered`](../api/core/operators/rxobservableprototypepausablebufferedpauser)
- [`pluck`](../api/core/operators/rxobservableprototypepluckproperty)
- [`publish`](../api/core/operators/rxobservableprototypepublishselector)
- [`publishLast`](../api/core/operators/rxobservableprototypepublishlatestselector)
- [`publishValue`](../api/core/operators/rxobservableprototypepublishvalueselector)
- [`share`](../api/core/operators/rxobservableprototypeshare)
- [`shareReplay`](../api/core/operators/rxobservableprototypesharereplay)
- [`shareValue`](../api/core/operators/rxobservableprototypesharevalue)
- [`refCount`](../api/core/operators/connectableobservableprototyperefcount)
- [`reduce`](../api/core/operators/rxobservableprototypereduceaccumulator-seed)
- [`repeat`](../api/core/operators/rxobservableprototyperepeatrepeatcount)
- [`replay`](../api/core/operators/rxobservableprototypereplayselector-buffersize-window-scheduler)
- [`retry`](../api/core/operators/rxobservableprototyperetryretrycount)
- [`sample`](../api/core/operators/rxobservableprototypesampleinterval--sampleobservable)
- [`scan`](../api/core/operators/rxobservableprototypescanseed-accumulator)
- [`select`](../api/core/operators/rxobservableprototypeselectselector-thisarg)
- [`selectConcat`](../api/core/operators/rxobservableprototypeselectconcatselector-resultselector)
- [`selectMany`](../api/core/operators/rxobservableprototypeselectmanyselector-resultselector)
- [`selectManyObserver`](../api/core/operators/selectmanyobserver.md)
- [`selectSwitch`](../api/core/operators/rxobservableprototypeselectswitchselector-thisarg)
- [`sequenceEqual`](../api/core/operators/rxobservableprototypesequenceequalsecond-comparer)
- [`single`](../api/core/operators/rxobservableprototypesinglepredicate-thisarg)
- [`singleOrDefault`](../api/core/operators/rxobservableprototypesingleordefaultpredicate-defaultvalue-thisarg)
- [`skip`](../api/core/operators/rxobservableprototypeskipcount)
- [`skipLast`](../api/core/operators/rxobservableprototypeskiplastcount)
- [`skipLastWithTime`](../api/core/operators/rxobservableprototypeskiplastwithtimeduration)
- [`skipUntil`](../api/core/operators/rxobservableprototypeskipuntilother)
- [`skipUntilWithTime`](../api/core/operators/rxobservableprototypeskipuntilstarttime-scheduler)
- [`skipWhile`](../api/core/operators/rxobservableprototypeskipwhilepredicate-thisarg)
- [`some`](../api/core/operators/rxobservableprototypesomepredicate-thisarg)
- [`startWith`](../api/core/operators/rxobservableprototypestartwithscheduler-args)
- [`subscribe`](../api/core/operators/rxobservableprototypesubscribeobserver--onnext-onerror-oncompleted)
- [`subscribeOn`](../api/core/operators/rxobservableprototypesubscribeonscheduler)
- [`sum`](../api/core/operators/rxobservableprototypesumkeyselector-thisarg)
- [`switch | switchLatest`](../api/core/operators/rxobservableprototypeswitch)
- [`take`](../api/core/operators/rxobservableprototypetakecount-scheduler)
- [`takeLast`](../api/core/operators/rxobservableprototypetakelastcount)
- [`takeLastBuffer`](../api/core/operators/rxobservableprototypetakelastbuffercount)
- [`takeLastBufferWithTime`](../api/core/operators/rxobservableprototypetakelastbufferwithtimeduration-scheduler)
- [`takeLastWithTime`](../api/core/operators/rxobservableprototypetakelastwithtimeduration-timescheduler-loopscheduler)
- [`takeUntil`](../api/core/operators/rxobservableprototypetakeuntilother)
- [`takeUntilWithTime`](../api/core/operators/rxobservableprototypetakeuntilwithtimeendtime-scheduler)
- [`takeWhile`](../api/core/operators/rxobservableprototypetakewhilepredicate-thisarg)
- [`throttle`](../api/core/operators/rxobservableprototypethrottleduetime-scheduler)
- [`throttleWithSelector`](../api/core/operators/rxobservableprototypethrottlewithselectorthrottleselector)
- [`timeInterval`](../api/core/operators/rxobservableprototypetimeintervalscheduler)
- [`timeout`](../api/core/operators/rxobservableprototypetimeoutduetime-other-scheduler)
- [`timeoutWithSelector`](../api/core/operators/rxobservableprototypetimeoutwithselectorfirsttimeout-timeoutdurationselector-other)
- [`timestamp`](../api/core/operators/rxobservableprototypetimestampscheduler)
- [`toArray`](../api/core/operators/rxobservableprototypetoarray)
- [`where`](../api/core/operators/rxobservableprototypewherepredicate-thisarg)
- [`window`](../api/core/operators/rxobservableprototypewindowwindowopenings-windowboundaries-windowclosingselector)
- [`windowWithCount`](../api/core/operators/rxobservableprototypewindowwithcountcount-skip)
- [`windowWithTime`](../api/core/operators/rxobservableprototypewindowwithtimetimespan-timeshift--scheduler)
- [`windowWithTimeOrCount`](../api/core/operators/rxobservableprototypewindowwithtimeorcounttimespan-count-scheduler)
- [`zip`](../api/core/operators/rxobservableprototypezipargs-resultselector)
## Included Classes ##

### Core Objects

- [`Rx.Observer`](../api/core/observer.md)
- [`Rx.Notification`](../api/core/notification.md)

### Subjects

- [`Rx.AsyncSubject`](../api/subjects/asyncsubject.md)
- [`Rx.Subject`](../api/subjects/subject.md)

### Schedulers

- [`Rx.Scheduler`](../api/schedulers/scheduler.md)

### Disposables

- [`Rx.CompositeDisposable`](../api/disposables/compositedisposable.md)
- [`Rx.Disposable`](../api/disposables/disposable.md)
- [`Rx.RefCountDisposable`](../api/disposables/refcountdisposable.md)
- [`Rx.SerialDisposable`](../api/disposables/serialdisposable.md)
- [`Rx.SingleAssignmentDisposable`](../api/disposables/singleassignmentdisposable.md)
